/**
 * <copyright>
 * </copyright>
 *
 * $Id: DublinCoreItemProviderAdapterFactory.java,v 1.1 2008-01-21 15:40:18 vmahe Exp $
 */
package org.dublincore.DublinCore.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.dublincore.DublinCore.util.DublinCoreAdapterFactory;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DublinCoreItemProviderAdapterFactory extends DublinCoreAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DublinCoreItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Metadata} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MetadataItemProvider metadataItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Metadata}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMetadataAdapter() {
		if (metadataItemProvider == null) {
			metadataItemProvider = new MetadataItemProvider(this);
		}

		return metadataItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Contributor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ContributorItemProvider contributorItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Contributor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createContributorAdapter() {
		if (contributorItemProvider == null) {
			contributorItemProvider = new ContributorItemProvider(this);
		}

		return contributorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Coverage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CoverageItemProvider coverageItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Coverage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCoverageAdapter() {
		if (coverageItemProvider == null) {
			coverageItemProvider = new CoverageItemProvider(this);
		}

		return coverageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Creator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CreatorItemProvider creatorItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Creator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCreatorAdapter() {
		if (creatorItemProvider == null) {
			creatorItemProvider = new CreatorItemProvider(this);
		}

		return creatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Date} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateItemProvider dateItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Date}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateAdapter() {
		if (dateItemProvider == null) {
			dateItemProvider = new DateItemProvider(this);
		}

		return dateItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Description} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DescriptionItemProvider descriptionItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Description}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDescriptionAdapter() {
		if (descriptionItemProvider == null) {
			descriptionItemProvider = new DescriptionItemProvider(this);
		}

		return descriptionItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Format} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FormatItemProvider formatItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Format}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFormatAdapter() {
		if (formatItemProvider == null) {
			formatItemProvider = new FormatItemProvider(this);
		}

		return formatItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Identifier} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IdentifierItemProvider identifierItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Identifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIdentifierAdapter() {
		if (identifierItemProvider == null) {
			identifierItemProvider = new IdentifierItemProvider(this);
		}

		return identifierItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Language} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LanguageItemProvider languageItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Language}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLanguageAdapter() {
		if (languageItemProvider == null) {
			languageItemProvider = new LanguageItemProvider(this);
		}

		return languageItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Publisher} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected PublisherItemProvider publisherItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Publisher}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createPublisherAdapter() {
		if (publisherItemProvider == null) {
			publisherItemProvider = new PublisherItemProvider(this);
		}

		return publisherItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Relation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RelationItemProvider relationItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Relation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRelationAdapter() {
		if (relationItemProvider == null) {
			relationItemProvider = new RelationItemProvider(this);
		}

		return relationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Rights} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RightsItemProvider rightsItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Rights}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRightsAdapter() {
		if (rightsItemProvider == null) {
			rightsItemProvider = new RightsItemProvider(this);
		}

		return rightsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Source} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SourceItemProvider sourceItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Source}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSourceAdapter() {
		if (sourceItemProvider == null) {
			sourceItemProvider = new SourceItemProvider(this);
		}

		return sourceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Subject} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected SubjectItemProvider subjectItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Subject}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createSubjectAdapter() {
		if (subjectItemProvider == null) {
			subjectItemProvider = new SubjectItemProvider(this);
		}

		return subjectItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Title} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TitleItemProvider titleItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Title}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTitleAdapter() {
		if (titleItemProvider == null) {
			titleItemProvider = new TitleItemProvider(this);
		}

		return titleItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Type} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TypeItemProvider typeItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Type}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTypeAdapter() {
		if (typeItemProvider == null) {
			typeItemProvider = new TypeItemProvider(this);
		}

		return typeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Dataset} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DatasetItemProvider datasetItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Dataset}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDatasetAdapter() {
		if (datasetItemProvider == null) {
			datasetItemProvider = new DatasetItemProvider(this);
		}

		return datasetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Alternative} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AlternativeItemProvider alternativeItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Alternative}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAlternativeAdapter() {
		if (alternativeItemProvider == null) {
			alternativeItemProvider = new AlternativeItemProvider(this);
		}

		return alternativeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Abstract} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AbstractItemProvider abstractItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Abstract}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAbstractAdapter() {
		if (abstractItemProvider == null) {
			abstractItemProvider = new AbstractItemProvider(this);
		}

		return abstractItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.TableOfContents} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected TableOfContentsItemProvider tableOfContentsItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.TableOfContents}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createTableOfContentsAdapter() {
		if (tableOfContentsItemProvider == null) {
			tableOfContentsItemProvider = new TableOfContentsItemProvider(this);
		}

		return tableOfContentsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Available} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AvailableItemProvider availableItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Available}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAvailableAdapter() {
		if (availableItemProvider == null) {
			availableItemProvider = new AvailableItemProvider(this);
		}

		return availableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Created} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected CreatedItemProvider createdItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Created}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createCreatedAdapter() {
		if (createdItemProvider == null) {
			createdItemProvider = new CreatedItemProvider(this);
		}

		return createdItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.DateAccepted} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateAcceptedItemProvider dateAcceptedItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.DateAccepted}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateAcceptedAdapter() {
		if (dateAcceptedItemProvider == null) {
			dateAcceptedItemProvider = new DateAcceptedItemProvider(this);
		}

		return dateAcceptedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.DateCopyrighted} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateCopyrightedItemProvider dateCopyrightedItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.DateCopyrighted}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateCopyrightedAdapter() {
		if (dateCopyrightedItemProvider == null) {
			dateCopyrightedItemProvider = new DateCopyrightedItemProvider(this);
		}

		return dateCopyrightedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.DateSubmitted} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected DateSubmittedItemProvider dateSubmittedItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.DateSubmitted}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createDateSubmittedAdapter() {
		if (dateSubmittedItemProvider == null) {
			dateSubmittedItemProvider = new DateSubmittedItemProvider(this);
		}

		return dateSubmittedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Issued} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IssuedItemProvider issuedItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Issued}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIssuedAdapter() {
		if (issuedItemProvider == null) {
			issuedItemProvider = new IssuedItemProvider(this);
		}

		return issuedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Modified} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ModifiedItemProvider modifiedItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Modified}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createModifiedAdapter() {
		if (modifiedItemProvider == null) {
			modifiedItemProvider = new ModifiedItemProvider(this);
		}

		return modifiedItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsPartOf} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsPartOfItemProvider isPartOfItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsPartOf}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsPartOfAdapter() {
		if (isPartOfItemProvider == null) {
			isPartOfItemProvider = new IsPartOfItemProvider(this);
		}

		return isPartOfItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsVersionOf} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsVersionOfItemProvider isVersionOfItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsVersionOf}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsVersionOfAdapter() {
		if (isVersionOfItemProvider == null) {
			isVersionOfItemProvider = new IsVersionOfItemProvider(this);
		}

		return isVersionOfItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsFormatOf} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsFormatOfItemProvider isFormatOfItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsFormatOf}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsFormatOfAdapter() {
		if (isFormatOfItemProvider == null) {
			isFormatOfItemProvider = new IsFormatOfItemProvider(this);
		}

		return isFormatOfItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.HasFormat} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HasFormatItemProvider hasFormatItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.HasFormat}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHasFormatAdapter() {
		if (hasFormatItemProvider == null) {
			hasFormatItemProvider = new HasFormatItemProvider(this);
		}

		return hasFormatItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsReferencedBy} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsReferencedByItemProvider isReferencedByItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsReferencedBy}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsReferencedByAdapter() {
		if (isReferencedByItemProvider == null) {
			isReferencedByItemProvider = new IsReferencedByItemProvider(this);
		}

		return isReferencedByItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.References} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ReferencesItemProvider referencesItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.References}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createReferencesAdapter() {
		if (referencesItemProvider == null) {
			referencesItemProvider = new ReferencesItemProvider(this);
		}

		return referencesItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsBasisFor} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsBasisForItemProvider isBasisForItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsBasisFor}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsBasisForAdapter() {
		if (isBasisForItemProvider == null) {
			isBasisForItemProvider = new IsBasisForItemProvider(this);
		}

		return isBasisForItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.IsBasedOn} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IsBasedOnItemProvider isBasedOnItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.IsBasedOn}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createIsBasedOnAdapter() {
		if (isBasedOnItemProvider == null) {
			isBasedOnItemProvider = new IsBasedOnItemProvider(this);
		}

		return isBasedOnItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Requires} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RequiresItemProvider requiresItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Requires}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRequiresAdapter() {
		if (requiresItemProvider == null) {
			requiresItemProvider = new RequiresItemProvider(this);
		}

		return requiresItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.AccessRights} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AccessRightsItemProvider accessRightsItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.AccessRights}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAccessRightsAdapter() {
		if (accessRightsItemProvider == null) {
			accessRightsItemProvider = new AccessRightsItemProvider(this);
		}

		return accessRightsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.License} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LicenseItemProvider licenseItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.License}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLicenseAdapter() {
		if (licenseItemProvider == null) {
			licenseItemProvider = new LicenseItemProvider(this);
		}

		return licenseItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Audience} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AudienceItemProvider audienceItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Audience}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAudienceAdapter() {
		if (audienceItemProvider == null) {
			audienceItemProvider = new AudienceItemProvider(this);
		}

		return audienceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.BibliographicCitation} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected BibliographicCitationItemProvider bibliographicCitationItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.BibliographicCitation}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createBibliographicCitationAdapter() {
		if (bibliographicCitationItemProvider == null) {
			bibliographicCitationItemProvider = new BibliographicCitationItemProvider(this);
		}

		return bibliographicCitationItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Provenance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProvenanceItemProvider provenanceItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Provenance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createProvenanceAdapter() {
		if (provenanceItemProvider == null) {
			provenanceItemProvider = new ProvenanceItemProvider(this);
		}

		return provenanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.RightsHolder} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected RightsHolderItemProvider rightsHolderItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.RightsHolder}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createRightsHolderAdapter() {
		if (rightsHolderItemProvider == null) {
			rightsHolderItemProvider = new RightsHolderItemProvider(this);
		}

		return rightsHolderItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.Mediator} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected MediatorItemProvider mediatorItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.Mediator}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createMediatorAdapter() {
		if (mediatorItemProvider == null) {
			mediatorItemProvider = new MediatorItemProvider(this);
		}

		return mediatorItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.EducationLevel} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EducationLevelItemProvider educationLevelItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.EducationLevel}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createEducationLevelAdapter() {
		if (educationLevelItemProvider == null) {
			educationLevelItemProvider = new EducationLevelItemProvider(this);
		}

		return educationLevelItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link org.dublincore.DublinCore.ExternalStorage} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ExternalStorageItemProvider externalStorageItemProvider;

	/**
	 * This creates an adapter for a {@link org.dublincore.DublinCore.ExternalStorage}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createExternalStorageAdapter() {
		if (externalStorageItemProvider == null) {
			externalStorageItemProvider = new ExternalStorageItemProvider(this);
		}

		return externalStorageItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (metadataItemProvider != null) metadataItemProvider.dispose();
		if (contributorItemProvider != null) contributorItemProvider.dispose();
		if (coverageItemProvider != null) coverageItemProvider.dispose();
		if (creatorItemProvider != null) creatorItemProvider.dispose();
		if (dateItemProvider != null) dateItemProvider.dispose();
		if (descriptionItemProvider != null) descriptionItemProvider.dispose();
		if (formatItemProvider != null) formatItemProvider.dispose();
		if (identifierItemProvider != null) identifierItemProvider.dispose();
		if (languageItemProvider != null) languageItemProvider.dispose();
		if (publisherItemProvider != null) publisherItemProvider.dispose();
		if (relationItemProvider != null) relationItemProvider.dispose();
		if (rightsItemProvider != null) rightsItemProvider.dispose();
		if (sourceItemProvider != null) sourceItemProvider.dispose();
		if (subjectItemProvider != null) subjectItemProvider.dispose();
		if (titleItemProvider != null) titleItemProvider.dispose();
		if (typeItemProvider != null) typeItemProvider.dispose();
		if (datasetItemProvider != null) datasetItemProvider.dispose();
		if (alternativeItemProvider != null) alternativeItemProvider.dispose();
		if (abstractItemProvider != null) abstractItemProvider.dispose();
		if (tableOfContentsItemProvider != null) tableOfContentsItemProvider.dispose();
		if (availableItemProvider != null) availableItemProvider.dispose();
		if (createdItemProvider != null) createdItemProvider.dispose();
		if (dateAcceptedItemProvider != null) dateAcceptedItemProvider.dispose();
		if (dateCopyrightedItemProvider != null) dateCopyrightedItemProvider.dispose();
		if (dateSubmittedItemProvider != null) dateSubmittedItemProvider.dispose();
		if (issuedItemProvider != null) issuedItemProvider.dispose();
		if (modifiedItemProvider != null) modifiedItemProvider.dispose();
		if (isPartOfItemProvider != null) isPartOfItemProvider.dispose();
		if (isVersionOfItemProvider != null) isVersionOfItemProvider.dispose();
		if (isFormatOfItemProvider != null) isFormatOfItemProvider.dispose();
		if (hasFormatItemProvider != null) hasFormatItemProvider.dispose();
		if (isReferencedByItemProvider != null) isReferencedByItemProvider.dispose();
		if (referencesItemProvider != null) referencesItemProvider.dispose();
		if (isBasisForItemProvider != null) isBasisForItemProvider.dispose();
		if (isBasedOnItemProvider != null) isBasedOnItemProvider.dispose();
		if (requiresItemProvider != null) requiresItemProvider.dispose();
		if (accessRightsItemProvider != null) accessRightsItemProvider.dispose();
		if (licenseItemProvider != null) licenseItemProvider.dispose();
		if (audienceItemProvider != null) audienceItemProvider.dispose();
		if (bibliographicCitationItemProvider != null) bibliographicCitationItemProvider.dispose();
		if (provenanceItemProvider != null) provenanceItemProvider.dispose();
		if (rightsHolderItemProvider != null) rightsHolderItemProvider.dispose();
		if (mediatorItemProvider != null) mediatorItemProvider.dispose();
		if (educationLevelItemProvider != null) educationLevelItemProvider.dispose();
		if (externalStorageItemProvider != null) externalStorageItemProvider.dispose();
	}

}
